<?php
/**
 # sudoku_ajax.php
 #
 # Sudoku ajax backend:  responds to ajax request and sends a sudoku puzzle
 #
 # @author Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 # @copyright Copyright (C) 2021 Joachim Schmidt. All rights reserved.
 # @license	 http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 #
 # change activity:
 #        12.09.2022: changed $_REQUEST to  joomla's  input-API
 */
defined('_JEXEC') or die('can only run under Joomla with extension &quot;jphpx&quot;!');
use Joomla\CMS\Factory;

$ini_file = JPATH_ROOT . "/components/com_jphpx/demo/sudoku.ini";
$settings = parse_ini_file($ini_file, true);

$valid_languages = $settings['languages'];

$tmp = Factory::getApplication()->getLanguage();
$lang = substr($tmp->getTag(), 0, 2);

if (strpos($valid_languages, $lang) === false)
    $lang = "en";

$text = $settings[$lang];

$input = Factory::getApplication()->input;

if ( $input->get('level') )
    $level = $input->getInt('level');
else
    $level = "0";

$puzzles = JPATH_ROOT . "/components/com_jphpx/demo/puzzles.l" . $level;
$max = getAnzSudokus($level, $puzzles);

if ( $input->get('sudoku') && is_numeric($input->get('sudoku')) )
    $sudokuid = $input->getInt('sudoku');
else
    $sudokuid = rand(0, $max);

if ($sudokuid < 0 || $sudokuid > $max)
    $sudokuid = rand(0, $max);

echo getSudokuPuzzle($sudokuid, $level, $puzzles, $text);
exit();

function getSudokuPuzzle ($sudokuid, $level, $puzzles, $text)
{
    $result = array();
    $string = "level" . $level;
    $result['puzzle_id'] = $sudokuid . " (" . $text[$string] . ")";
    $result['puzzle'] = getSudoku($sudokuid, $puzzles);
    return json_encode($result);
    // return $result;
}

function getSudoku ($line, $puzzles)
{
    $ls = 82;

    $size = filesize($puzzles);
    $lines = $size / $ls;
    if ($line > $lines)
    {
        $line = $lines - 1;
    }

    $handle = fopen($puzzles, "r");
    $pos = $ls * $line;
    fseek($handle, $pos, SEEK_SET);
    $contents = fread($handle, $ls - 1);
    fclose($handle);
    return $contents;
}

function getAnzSudokus ($level, $puzzles)
{
    $ls = 82;
    $size = filesize($puzzles);
    $lines = $size / $ls;
    return intval($lines) - 1;
}
?>
