<?php
/*
 *  @package   jphpx Joomla! Plugin
 *  @version   Version 1.3.3
 *  @author    Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 *  @copyright (C) 2021 Joachim Schmidt. All rights reserved.
 *  @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 *
 * change activity:
 */
defined('_JEXEC') or die('Restricted access');
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Version;

jimport('joomla.application.component.view');

class JphpxViewApplication extends \Joomla\CMS\MVC\View\HtmlView
{

    function display ($tpl = null)
    {
        $fileid = Factory::getApplication()->input->getInt('fileid');
        $document = Factory::getApplication()->getDocument();
        $joomla_version = new Version();

        if (version_compare($joomla_version->getShortVersion(), '4.0', '>='))
        {
            $database = Factory::getContainer()->get('DatabaseDriver');
            $user = Factory::getApplication()->getIdentity();
        }
        else
        {
            $database = Factory::getDBO();
            $user = Factory::getUser();
        }

        if ($user->id == 0)
            $database->setQuery("select source,title from #__jphpx where id = '{$fileid}' and published = 1 and access = 0");
        else
            $database->setQuery("select source,title from #__jphpx where id = '{$fileid}' and published = 1");

        $appl = $database->loadObject();

        if (! is_object($appl))
        {
            echo '<div style="color:red;">&nbsp;' . Text::_("COM_ERROR_APP") . '</div>';
            return false;
        }

        $document->setTitle($appl->title);

        if (! empty($appl->source))
        {

            $filepath = JPATH_ROOT . "/" . $appl->source;
            if (is_file($appl->source))
            {
                require ($appl->source);
            }
            elseif (is_file($filepath))
                require $filepath;
            else
                echo '<div style="color:red;">&nbsp;' . Text::sprintf('COM_ERROR_FILE', $filepath) . '</div>';
        }

        parent::display($tpl);
     }
}
