/**
 # sudoku.js
 #
 # javascript interface for sudoku app 
 #  
 # @author Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 # @copyright Copyright (C) 2014 Joachim Schmidt. All rights reserved.
 # @license	 http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 #
 # change activity:
 #        24.09.2022: added support for using own sudoku puzzles
 */
var solution,my_puzzle,number_color,owm_puzzle=!1;function printpuzzle(){var e=document.getElementById("sudoku_grid");newWin=window.open(""),newWin.document.write(e.outerHTML),newWin.print(),newWin.close()}function getPuzzle(e,r){if(e=e+"&lang="+jQuery("#language").text(),"null"==r){for(var i=0,u=0;u<4;++u)1==jQuery("#level"+u).prop("checked")&&(i=jQuery("#level"+u).val());if(3==i)return showOwnSudoku(my_puzzle="................................................................................."),void(owm_puzzle=!0);e=e+"&sudokuid=null&level="+i}else e+=r;jQuery("#button1").prop("disabled",!0),jQuery("#button2").prop("disabled",!0),jQuery("#button3").prop("disabled",!0),jQuery("#messages").attr("style","visibility: hidden"),jQuery.ajax({url:e,type:"GET",dataType:"json",error:function(e,r,i){jQuery("#button1").prop("disabled",!1),jQuery("#button2").prop("disabled",!1),jQuery("#button3").prop("disabled",!1),jQuery("#messages").html("<span style='color: red'>Ajax Error - Reason: "+e.status+" "+i+"</span>"),jQuery("#messages").attr("style","visibility: visible")},success:onSuccess,async:!0})}function onSuccess(e){jQuery("#button1").prop("disabled",!1),jQuery("#button2").prop("disabled",!1),jQuery("#button3").prop("disabled",!1);var r=sudoku_solver();solution="";for(var i=r(e.puzzle,2),u=0;u<i.length;++u)solution+=i[u].join("")+"\n";showSudoku(e.puzzle);var t=e.puzzle_id;t="de"==jQuery("#language").text()?t.toString().replace(/\B(?=(\d{3})+(?!\d))/g,"."):t.toString().replace(/\B(?=(\d{3})+(?!\d))/g,","),jQuery("#sudokuid").html("<h2>Sudoku - "+t+"</h2>")}function checkValues(){if(1!=own_puzzle)if(1==jQuery("#help").prop("checked")||1==jQuery("#check").prop("checked"))if(jQuery("#help").prop("checked")){showCandidates();for(var e=0;e<81;++e)0==jQuery("#i"+e).prop("readonly")&&checkValue(e,!1,!1)}else for(e=0;e<81;++e)jQuery("#candidates"+e).attr("style","visibility: hidden"),checkValue(e,!1,!1);else for(e=0;e<81;++e)jQuery("#candidates"+e).attr("style","visibility: hidden")}function checkNumber(e,r){for(var i=new Array(9),u=0;u<10;u++)i[u]=new Array(9);var t=0;for(u=0;u<9;u++)for(var l=0;l<9;l++)i[u][l]=my_puzzle.substr(t,1),t++;var o=parseInt(e/9);if(i[o].find((e=>e==r)))return!1;var s=e%9;for(u=0;u<9;u++)if(i[u][s]==r)return!1;return!checkNumberinBox(getBoxNr(o,s),i,r)}function checkValue(e,r,i){var u=jQuery("#i"+e).val();1!=jQuery("#i"+e).prop("readonly")&&(isNaN(u)||"0"===u?jQuery("#i"+e).val(""):1==own_puzzle?""!=u?1==checkNumber(e,u)?(my_puzzle=my_puzzle.substring(0,e)+u+my_puzzle.substring(e+1),jQuery("#i"+e).val(my_puzzle.substr(e,1)),jQuery("#i"+e).attr("readonly",!1),jQuery("#candidates"+e).html(null),jQuery("#candidates"+e).attr("style","visibility: hidden")):(jQuery("#i"+e).val(""),my_puzzle=my_puzzle.substring(0,e)+"."+my_puzzle.substring(e+1)):my_puzzle=my_puzzle.substring(0,e)+"."+my_puzzle.substring(e+1):solution.substr(e,1)!=u&&""!=jQuery("#i"+e).val()?1!=jQuery("#help").prop("checked")&&1!=jQuery("#check").prop("checked")||jQuery("#i"+e).attr("style","color: red"):(jQuery("#i"+e).attr("style","color: green"),1==jQuery("#help").prop("checked")&&1==i&&showCandidates(),checkSolved(r)))}function checkSolved(e){for(var r=!0,i=0;i<81;++i)jQuery("#i"+i).val()!=solution.substr(i,1)&&(r=!1),1==jQuery("#i"+i).prop("readonly")&&null==number_color&&(number_color=jQuery("#i"+i).css("color"));1==r&&1==e&&(jQuery("#button2").attr("style","visibility: hidden"),jQuery("#messages").html(jQuery("#msgbox_content").html()),jQuery("#messages").css("visibility","visible").hide().fadeIn()),0==r&&(jQuery("#button2").attr("style","visibility: visible"),jQuery("#messages").attr("style","visibility: hidden"))}function showOwnSudoku(e){own_puzzle=!0,soöution="";var r=jQuery("input[name='level']:checked").parent("label").text();jQuery("#sudokuid").html("<h2>Sudoku - "+r+"</h2>");for(var i=0;i<81;++i)jQuery("#i"+i).val(""),jQuery("#i"+i).attr("readonly",!1),jQuery("#i"+i).removeClass("sudoku-number"),jQuery("#i"+i).addClass("sudoku-nonumber"),jQuery("#candidates"+i).html(null),solution[i]="0";var u=jQuery("#msgbox_content2").html();jQuery("#messages").html(u),jQuery("#messages").attr("style","visibility: visible"),jQuery("#button3").attr("style","visibility: hidden"),jQuery("#button2").attr("style","visibility: hidden"),jQuery("#lbl_help").attr("style","visibility: hidden"),jQuery("#button4").attr("style","visibility: visible")}function setOwnPuzzle(){for(var e=0,r=0;r<81;++r)isNaN(my_puzzle.substr(r,1))||e++;if(!(e<17)){var i=sudoku_solver();solution="";var u=i(my_puzzle,2);for(r=0;r<u.length;++r)solution+=u[r].join("")+"\n";showSudoku(my_puzzle),jQuery("#button4").attr("style","visibility: hidden"),jQuery("#messages").attr("style","visibility: hidden")}}function showSudoku(e){own_puzzle=!1;for(var r=0;r<81;++r)"."!=e.substr(r,1)?(jQuery("#i"+r).val(e.substr(r,1)),jQuery("#i"+r).attr("readonly",!0),jQuery("#i"+r).removeClass("sudoku-nonumber"),jQuery("#i"+r).addClass("sudoku-number"),number_color&&jQuery("#i"+r).css("color",number_color)):(jQuery("#i"+r).val(""),jQuery("#i"+r).attr("readonly",!1),jQuery("#i"+r).removeClass("sudoku-number"),jQuery("#i"+r).addClass("sudoku-nonumber")),1==jQuery("#help").prop("checked")?showCandidates():jQuery("#candidates"+r).attr("style","visibility: hidden");jQuery("#button2").attr("style","visibility: visible"),jQuery("#button3").attr("style","visibility: visible"),jQuery("#lbl_help").attr("style","visibility: visible"),jQuery("#button4").attr("style","visibility: hidden")}function showCandidates(){for(var e=new Array(9),r=0;r<10;r++)e[r]=new Array(9);var i=[],u=0;for(r=0;r<9;r++)for(var t=0;t<9;t++)e[r][t]=jQuery("#i"+u).val(),jQuery("#i"+u).val()!=solution.substr(u,1)&&(e[r][t]=""),u++;var l=new Array(9),o=new Array(9),s=new Array(9);for(r=0;r<9;r++)l[r]=[0,1,2,3,4,5,6,7,8,9],o[r]=[0,1,2,3,4,5,6,7,8,9],s[r]=[0,1,2,3,4,5,6,7,8,9],l[r]=checkRow(r,e,l[r]),o[r]=checkColumn(r,e,o[r]),s[r]=checkBox(r,e,s[r]);k=0;for(r=0;r<9;r++)for(t=0;t<9;t++){i[k]="";var n=!1;for(u=1;u<10;u++){var a=getBoxNr(r,t);l[r][u]==o[t][u]&&l[r][u]==s[a][u]&&0!=l[r][u]&&0!=o[t][u]&&0!=s[a][u]&&(i[k].length>4&&0==n?(i[k]+="<br />"+l[r][u],n=!0):i[k]+=l[r][u])}jQuery("#i"+k).val()==solution.substr(k,1)?jQuery("#candidates"+k).attr("style","visibility: hidden"):(jQuery("#candidates"+k).html(i[k]),jQuery("#candidates"+k).attr("style","visibility: visible")),k++}}function getBoxNr(e,r){var i=0;return e<3&&r<3&&(i=0),e<3&&r<6&&r>2&&(i=1),e<3&&r>5&&(i=2),e<6&&e>2&&r<3&&(i=3),e<6&&e>2&&r<6&&r>2&&(i=4),e<6&&e>2&&r>5&&(i=5),e>5&&r<3&&(i=6),e>5&&r<6&&r>2&&(i=7),e>5&&r>5&&(i=8),i}function checkRow(e,r,i){for(var u=0;u<9;u++)""!=r[e][u]&&(i[r[e][u]]=0);return i}function checkColumn(e,r,i){for(var u=0;u<9;u++)""!=r[u][e]&&(i[r[u][e]]=0);return i}function checkNumberinBox(e,r,i){0==e&&(bi=0,bj=0,li=3,lj=3),1==e&&(bi=0,bj=3,li=3,lj=6),2==e&&(bi=0,bj=6,li=3,lj=9),3==e&&(bi=3,bj=0,li=6,lj=3),4==e&&(bi=3,bj=3,li=6,lj=6),5==e&&(bi=3,bj=6,li=6,lj=9),6==e&&(bi=6,bj=0,li=9,lj=3),7==e&&(bi=6,bj=3,li=9,lj=6),8==e&&(bi=6,bj=6,li=9,lj=9);for(var u=bi;u<li;u++)for(var t=bj;t<lj;t++)if(r[u][t]==i)return!0;return!1}function checkBox(e,r,i){0==e&&(bi=0,bj=0,li=3,lj=3),1==e&&(bi=0,bj=3,li=3,lj=6),2==e&&(bi=0,bj=6,li=3,lj=9),3==e&&(bi=3,bj=0,li=6,lj=3),4==e&&(bi=3,bj=3,li=6,lj=6),5==e&&(bi=3,bj=6,li=6,lj=9),6==e&&(bi=6,bj=0,li=9,lj=3),7==e&&(bi=6,bj=3,li=9,lj=6),8==e&&(bi=6,bj=6,li=9,lj=9);for(var u=bi;u<li;u++)for(var t=bj;t<lj;t++)""!=r[u][t]&&"."!=r[u][t]&&(i[r[u][t]]=0);return i}function showSolution(){for(var e=0;e<81;++e)0==jQuery("#i"+e).prop("readonly")?(jQuery("#i"+e).val(solution.substr(e,1)),jQuery("#i"+e).css("color","green"),jQuery("#candidates"+e).attr("style","visibility: hidden")):null==number_color&&(number_color=jQuery("#i"+e).css("color"));jQuery("#button2").attr("style","visibility: hidden")}function sudoku_solver(){var e,r,i,u,t,l=[],o=[];for(e=i=0;e<9;++e)for(r=0;r<9;++r)for(k=0;k<9;++k)l[i++]=[9*e+r,9*(3*Math.floor(e/3)+Math.floor(r/3))+k+81,9*e+k+162,9*r+k+243];for(u=0;u<324;++u)o[u]=[];for(i=0;i<729;++i)for(t=0;t<4;++t)o[l[i][t]].push(i);function s(e,r,i,u){for(var t=10,s=0,n=0;n<4;++n)r[l[i][n]]+=u<<7;for(n=0;n<4;++n){var a,y,d,b=l[i][n];if(u>0){for(a=0;a<9;++a)if(0==e[y=o[b][a]]++)for(d=0;d<4;++d){var j=l[y][d];--r[j]<t&&(t=r[j],s=j)}}else for(a=0;a<9;++a)if(0==--e[y=o[b][a]]){var c=l[y];++r[c[0]],++r[c[1]],++r[c[2]],++r[c[3]]}}return t<<16|s}return function(e,r){var i,u,t,l,n=0,a=[],y=[],d=[],b=[],j=[],c=[];for(null==r&&(r=2),i=0;i<729;++i)a[i]=0;for(u=0;u<324;++u)y[u]=9;for(var v=0;v<81;++v){var f=e.charAt(v)>="1"&&e.charAt(v)<="9"?e.charCodeAt(v)-49:-1;f>=0&&s(a,y,9*v+f,1),f>=0&&++n,d[v]=b[v]=-1,j[v]=f+1}v=0;for(var Q=1,p=655360;;){for(;v>=0&&v<81-n;){if(1==Q){if(l=p>>16,b[v]=65535&p,l>1)for(u=0;u<324&&!(y[u]<l&&(l=y[u],b[v]=u,l<=1));++u);0!=l&&10!=l||(d[v--]=Q=-1)}for(u=b[v],-1==Q&&d[v]>=0&&s(a,y,o[u][d[v]],-1),t=d[v]+1;t<9&&0!=a[o[u][t]];++t);t<9?(p=s(a,y,o[u][t],1),d[v++]=t,Q=1):d[v--]=Q=-1}if(v<0)break;for(var h=[],k=0;k<81;++k)h[k]=j[k];for(k=0;k<v;++k)i=o[b[k]][d[k]],h[Math.floor(i/9)]=i%9+1;if(c.push(h),c.length>=r)return c;--v,Q=-1}return c}}